Subject: bug#28510: crash: guix build -S foo --with-source=bla

From: [email-masked]
Date: Fri, 07 Oct 2022 10:41:50 +0200

Le 2022-09-20 21:42, Josselin Poiret a écrit :
> Hi Simon,
> 
> zimoun <[email-masked]> writes:
> 
>> Well, I would add an error handler; as proposed [1]. :-)  Because does
>> “guix build foo --source --with-source=bla” make sense?  What is the
>> use-case for such command?
> 
> My bad, I didn't see the previous discussion on the subject.  To me, 
> the
> lack of generality would be unexpected: if I have a package with a
> source, I expect to be able to get that source, whatever the source may
> be.  Maxime's minimal example shows that it could happen for a variety
> of different reasons, not just a --with-source= flag.  I don't know 
> what
> a proper fix for it would be though, since we're passing things around
> that we pretend are derivations but are not, and in many places.
> 
> Best,

Hi !

I feel not able to take decision about the proper way right now.
So as a step forward I wrote a test to capture the behavior expected.
Please have a look at it as it's the starting point for me.
Next, I can implement the error handler, making the previous test to 
pass.
As the test checks the behaviour, it will let enough space to change 
implementation later without invalitating the test.

Cheers,
Jérémy